'    intsOLEGenerator.vbs
'::::::::::::::::::::::::::::::::::::::::::::::::::::::
'      ProgID-
Private Function GetPathFromProgID ( ProgID )
	Set objWSH = CreateObject("WScript.Shell")
	GetPathFromProgID = Null
	RKey = "HKCR\"+ProgID+"\CLSID\"
	dim PathFile
	Dim val
	PathFile = Null
	On Error Resume Next
	val = objWSH.RegRead(RKey)
	if Not IsEmpty(val) Then
		RKey = "HKCR\CLSID\"+val+"\InprocServer32\"
		KeyVal = objWSH.RegRead(RKey)
		if IsEmpty(KeyVal) Then
			RKey = "HKCR\CLSID\"+val+"\LocalServer\"
			KeyVal = objWSH.RegRead(RKey)
			if IsEmpty(KeyVal) Then
				RKey = "HKCR\CLSID\"+val+"\LocalServer32\"
				KeyVal = objWSH.RegRead(RKey)
			End IF
		End IF
		if Not IsEmpty(KeyVal) Then
			PathFile = KeyVal
		End IF
	End IF
	if IsNull(PathFile) Then
		Exit Function
	End IF
	GetPathFromProgID = PathFile
End Function

'     
Function GetTempFileFullName
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Const TemporaryFolder = 2
	GetTempFileFullName = objFSO.GetSpecialFolder(TemporaryFolder)+"\"+objFSO.GetTempName
End Function

'   /   --_--
Function GetDateTime
	dateNowDate = Now
	intDay = DatePart("d", dateNowDate)
	intMonth = DatePart("m", dateNowDate)
	intYear = DatePart("yyyy", dateNowDate)
	intHour = DatePart("h", dateNowDate)
	intMinute = DatePart("n", dateNowDate)
	intSecond = DatePart("s", dateNowDate)
	If intDay<10 Then
		intDay = "0" & intDay
	End If
	If intMonth<10 Then
		intMonth = "0" & intMonth
	End If
	If intHour<10 Then
		intHour = "0" & intHour
	End If
	If intMinute<10 Then
		intMinute = "0" & intMinute
	End If
	If intSecond<10 Then
		intSecond = "0" & intSecond
	End If
	GetDateTime = intDay & "-" & intMonth & "-" & intYear & "_" & intHour & "-" & intMinute & "-" & intSecond
End Function

'   
Set objArgs = WScript.Arguments

If objArgs.Count >= 2 Then

	Set objWShell = WScript.CreateObject ("WScript.Shell")
	Set objShell = CreateObject("Shell.Application")
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Dim str1CPath
	Dim strParameters
	Dim strTempFileName
	Dim strRun
	strParameters = ""

	If objArgs(0) = "v77" Then
		str1CPath = GetPathFromProgID("V77.Application")
	ElseIf objArgs(0) = "v81" Then
		str1CPath = GetPathFromProgID("V81.Application")
	ElseIf objArgs(0) = "v82" Then
		str1CPath = GetPathFromProgID("V82.Application")
	ElseIf objArgs(0) = "v82c" Then
		str1CPath = GetPathFromProgID("V82C.Application")
	End If
	
	If IsEmpty(str1CPath) Then
		MsgBox "1 " + objArgs(0) + "  !", vbCritical, ""
		WScript.Quit
	Else
		str1CPath = """" + str1CPath + """"
	End If
	
	strTempFileName = GetTempFileFullName
	
	If objArgs(0) = "v77" Then
		If objArgs(1) = "run" Then
			For i=2 To objArgs.Count-1
				strParameters = strParameters + " " + objArgs(i)
			Next
	
			strParameters = Replace(strParameters, "'", """")
			objShell.ShellExecute str1CPath, strParameters

		ElseIf objArgs(1) = "unload" Then
			Set objStream = objFSO.CreateTextFile(strTempFileName, True)
			objStream.WriteLine "[General]"
			objStream.WriteLine "Quit=1"
			objStream.WriteLine "UnloadData=1"
			objStream.WriteLine "[UnloadData]"
			objStream.WriteLine "UnloadToFile=""" & objArgs(2) & "_" & GetDateTime & ".zip"""
			objStream.WriteLine "IncludeUserDef=1"
			objStream.Close
			
			strRun = str1CPath & " config " & "//d""" & objArgs(2) & """ /@""" & strTempFileName & """"
			objWShell.Run strRun, 1, True
			
			objFSO.DeleteFile strTempFileName, True

		ElseIf objArgs(1) = "save" Then
			Set objStream = objFSO.CreateTextFile(strTempFileName, True)
			objStream.WriteLine "[General]"
			objStream.WriteLine "Quit=1"
			objStream.WriteLine "SaveData=1"
			objStream.WriteLine "[SaveData]"
			objStream.WriteLine "SaveToFile=""" & objArgs(2) & "_" & GetDateTime & ".zip"""
			objStream.Close
			
			strRun = str1CPath & " config " & "//d""" & objArgs(2) & """ /@""" & strTempFileName & """"
			objWShell.Run strRun, 1, True
			
			objFSO.DeleteFile strTempFileName, True

		ElseIf objArgs(1) = "checkrepair" Then
			Set objStream = objFSO.CreateTextFile(strTempFileName, True)
			objStream.WriteLine "[General]"
			objStream.WriteLine "Output=""" & objArgs(2) & GetDateTime & "_" & ".log"""
			objStream.WriteLine "Quit=1"
			objStream.WriteLine "CheckAndRepair=1"
			objStream.WriteLine "[CheckAndRepair]"
			objStream.WriteLine "Repair=1"
			objStream.WriteLine "PhysicalIntegrity=1"
			objStream.WriteLine "Reindex=1"
			objStream.WriteLine "RecalcSecondaries=1"
			objStream.WriteLine "RecalcTotals=1"
			objStream.WriteLine "Pack=1"
			objStream.WriteLine "SkipResolved=0"
			objStream.WriteLine "CreateForUnresolved=1"
			objStream.WriteLine "Reconstruct=1"
			objStream.Close
			
			strRun = str1CPath & " config " & "//d""" & objArgs(2) & """ /@""" & strTempFileName & """"
			objWShell.Run strRun, 1, True
			
			objFSO.DeleteFile strTempFileName, True
		End If

	ElseIf objArgs(0) = "v81" or objArgs(0) = "v82" or objArgs(0) = "v82c" Then
		If objArgs(1) = "run" Then
			For i=2 To objArgs.Count-1
				strParameters = strParameters + " " + objArgs(i)
			Next
	
			strParameters = Replace(strParameters, "'", """")
			objShell.ShellExecute str1CPath, strParameters

		ElseIf objArgs(1) = "unload" Then
			Set objStream = objFSO.CreateTextFile(strTempFileName, True)
			objStream.WriteLine "DESIGNER"
			objStream.WriteLine "/F""" & objArgs(2) & """"
			objStream.WriteLine "/DisableStartupMessages"
			objStream.WriteLine "/DumpIB""" & objArgs(2) & "_" & GetDateTime & ".dt"""
			objStream.WriteLine "/Visible"
			objStream.Close
			
			strRun = str1CPath & " /@""" & strTempFileName & """"
			objWShell.Run strRun, 1, True
			
			objFSO.DeleteFile strTempFileName, True
		ElseIf objArgs(1) = "saveconfig" Then
			Set objStream = objFSO.CreateTextFile(strTempFileName, True)
			objStream.WriteLine "DESIGNER"
			objStream.WriteLine "/F""" & objArgs(2) & """"
			objStream.WriteLine "/DisableStartupMessages"
			objStream.WriteLine "/DumpCfg""" & objArgs(2) & "_" & GetDateTime & ".cf"""
			objStream.WriteLine "/Visible"
			objStream.Close
			
			strRun = str1CPath & " /@""" & strTempFileName & """"
			objWShell.Run strRun, 1, True
			
			objFSO.DeleteFile strTempFileName, True
		ElseIf objArgs(1) = "checkrepair" Then
			Set objStream = objFSO.CreateTextFile(strTempFileName, True)
			objStream.WriteLine "DESIGNER"
			objStream.WriteLine "/F""" & objArgs(2) & """"
			objStream.WriteLine "/DisableStartupMessages"
			objStream.WriteLine "/IBCheckAndRepair -ReIndex -LogAndRefsIntegrity -RecalcTotals -IBCompression -Rebuild -BadRefCreate -BadDataCreate"
			objStream.WriteLine "/Out""" & objArgs(2) & "_" & GetDateTime & ".log"" -NoTruncate"
			objStream.WriteLine "/Visible"
			objStream.Close
			
			strRun = str1CPath & " /@""" & strTempFileName & """"
			objWShell.Run strRun, 1, True
			
			objFSO.DeleteFile strTempFileName, True
		End If
	End If
	
End If
